import { ComparatorFn } from '@collectable/core';
import { RedBlackTreeEntry } from './node';
import { PathNode } from './path';
export declare class RedBlackTreeIterator<K, V> implements IterableIterator<RedBlackTreeEntry<K, V>> {
    private _current;
    private _compare;
    private _reversed;
    static create<K, V>(current: PathNode<K, V>, compare: ComparatorFn<K>, reversed?: boolean): RedBlackTreeIterator<K, V>;
    private _begun;
    private constructor();
    private _next(reverse);
    private _findNext(reverse, inclusive, key);
    next(key?: K, inclusive?: boolean): IteratorResult<RedBlackTreeEntry<K, V>>;
    previous(key?: K, inclusive?: boolean): IteratorResult<RedBlackTreeEntry<K, V>>;
    clone(): RedBlackTreeIterator<K, V>;
    [Symbol.iterator](): IterableIterator<RedBlackTreeEntry<K, V>>;
}
export declare class RedBlackTreeKeyIterator<K, V = null> implements IterableIterator<K> {
    private _it;
    constructor(_it: RedBlackTreeIterator<K, V>);
    next(key?: K, inclusive?: boolean): IteratorResult<K>;
    previous(key?: K, inclusive?: boolean): IteratorResult<RedBlackTreeEntry<K, V>>;
    clone(): RedBlackTreeKeyIterator<K, V>;
    [Symbol.iterator](): IterableIterator<K>;
}
export declare class RedBlackTreeValueIterator<K, V> implements IterableIterator<V> {
    private _it;
    constructor(_it: RedBlackTreeIterator<K, V>);
    next(key?: K, inclusive?: boolean): IteratorResult<V>;
    previous(key?: K, inclusive?: boolean): IteratorResult<RedBlackTreeEntry<K, V>>;
    clone(): RedBlackTreeValueIterator<K, V>;
    [Symbol.iterator](): IterableIterator<V>;
}
